


MT(1L)            MISC. REFERENCE MANUAL PAGES             MT(1L)



NAME
     mt - control magnetic tape drive operation

SYNOPSIS
     mt [-V] [-f device]  [--file=device]  [--version]  operation
     [count]

DESCRIPTION
     This manual page documents the GNU version of mt.   mt  per-
     forms  the  given  operation,  which must be one of the tape
     operations listed below, on a tape drive.

     The default tape device to operate on is taken from the file
     /usr/include/sys/mtio.h  when  mt  is  compiled.   It can be
     overridden by giving a device file name in  the  environment
     variable TAPE or by a command line option (see below), which
     also overrides the environment variable.

     The device must be either a  character  special  file  or  a
     remote  tape  drive.  To use a tape drive on another machine
     as the archive, use a filename that starts with `HOSTNAME:'.
     The  hostname  can  be  preceded by a username and an `@' to
     access the remote tape drive as that user, if you have  per-
     mission  to  do  so  (typically  an  entry  in  that  user's
     `~/.rhosts' file).

     The available operations are listed below.  Unique abbrevia-
     tions are accepted.  Not all operations are available on all
     systems, or work on all types of tape drives.   Some  opera-
     tions  optionally  take  a  repeat count, which can be given
     after the operation name and defaults to 1.

     eof, weof
          Write count EOF marks at current position.

     fsf  Forward space count files.  The tape is  positioned  on
          the first block of the next file.

     bsf  Backward space count files.  The tape is positioned  on
          the first block of the next file.

     fsr  Forward space count records.

     bsr  Backward space count records.

     bsfm Backward space count file marks.   The  tape  is  posi-
          tioned  on  the  beginning-of-the-tape side of the file
          mark.

     asf  Absolute space to file  number  count.   Equivalent  to
          rewind followed by fsf count.




Sun Release 4.1           Last change:                          1






MT(1L)            MISC. REFERENCE MANUAL PAGES             MT(1L)



     eom  Space to the end of the recorded media on the tape (for
          appending files onto tapes).

     rewind
          Rewind the tape.

     offline, rewoffl
          Rewind the tape and, if applicable, unload the tape.

     status
          Print status information about the tape unit.

     retension
          Rewind the tape, then wind it to the end of  the  reel,
          then rewind it again.

     erase
          Erase the tape.

     mt exits with a status of 0 if the operation succeeded, 1 if
     the  operation or device name given was invalid, or 2 if the
     operation failed.

  OPTIONS
     -f, --file=device
          Use device as the  file  name  of  the  tape  drive  to
          operate  on.   To  use a tape drive on another machine,
          use a filename that starts with `HOSTNAME:'.  The host-
          name can be preceded by a username and an `@' to access
          the remote tape drive as that user, if you have permis-
          sion  to  do  so  (typically  an  entry  in that user's
          `~/.rhosts' file).

     -V, --version
          Print the version number of mt.




















Sun Release 4.1           Last change:                          2



