


NL(1L)            MISC. REFERENCE MANUAL PAGES             NL(1L)



NAME
     nl - number lines of files

SYNOPSIS
     nl [-h header-style] [-b body-style] [-f footer-style]  [-p]
     [-d  cc]  [-v  start-number]  [-i  increment] [-l lines] [-s
     line-separator]   [-w   line-no-width]    [-n    {ln,rn,rz}]
     [--header-numbering=style]          [--body-numbering=style]
     [--footer-numbering=style]  [--first-page=number]   [--page-
     increment=number]       [--no-renumber]       [--join-blank-
     lines=number]     [--number-separator=string]     [--number-
     width=number]    [--number-format={ln,rn,rz}]    [--section-
     delimiter=cc] [--help] [--version] [file...]

DESCRIPTION
     This manual page documents the GNU version of nl.  nl copies
     each  given file, or the standard input if none are given or
     when a file named `-' is given, to the standard output, with
     line numbers added to some or all of the lines.

     nl considers its input to be composed of logical  pages;  by
     default,  the  line  number is reset to 1 at the top of each
     logical page.  nl treats all of the input files as a  single
     document;  it  does  not reset line numbers or logical pages
     between files.

     A logical page consists of three sections: header, body, and
     footer.  Any of the sections can be empty.  Each can be num-
     bered in a different style from the others.

     The beginnings of the sections of logical  pages  are  indi-
     cated  in the input file by a line containing nothing except
     one of the delimiter strings shown below:

     \:\:\: start of header
     \:\: start of body
     \: start of footer

     The two characters from which these strings are made can  be
     changed  with  an  option  (see  below), but the pattern and
     length of each string cannot be changed.

     The section delimiter strings are replaced by an empty  line
     on  output.   Any  text  that comes before the first section
     delimiter string in the input file is considered to be  part
     of  a body section, so a file that does not contain any sec-
     tion delimiter strings is considered to consist of a  single
     body section.

  OPTIONS
     -h, --header-numbering=style
          See --footer-numbering.



FSF              Last change: GNU Text Utilities                1






NL(1L)            MISC. REFERENCE MANUAL PAGES             NL(1L)



     -b, --body-numbering=style
          See --footer-numbering.

     -f, --footer-numbering=style
          Select the numbering style for lines in the footer sec-
          tion  of  each  logical  page.  When a line is not num-
          bered, the current line number is not incremented,  but
          the  line number separator character is still prepended
          to the line.  The styles are:

          a    number all lines

          t    number only nonempty lines (default for body)

          n    number no lines (default for header and footer)

          pregexp
               number only lines that contain a match for regexp

     -p, --no-renumber
          Do not reset the line number at the start of a  logical
          page.

     -v, --first-page=number
          Set the initial line number on  each  logical  page  to
          number (default 1).

     -i, --page-increment=number
          Increment line numbers by number (default 1).

     -l, --join-blank-lines=number
          Consider number (default 1) consecutive empty lines  to
          be  one logical line for numbering, and only number the
          last one.  Where fewer than  number  consecutive  empty
          lines  occur, do not number them.  An empty line is one
          that contains no characters, not even spaces or tabs.

     -s, --number-separator=string
          Separate the line number from the text line in the out-
          put with string (default is a TAB character).

     -w, --number-width=number
          Use number characters for line numbers (default 6).

     -n, --number-format={ln,rn,rz}
          Select the line numbering format:

          ln   left justified, no leading zeros

          rn   right justified, no leading zeros (default)

          rz   right justified, leading zeros



FSF              Last change: GNU Text Utilities                2






NL(1L)            MISC. REFERENCE MANUAL PAGES             NL(1L)



     -d, --section-delimiter=cc
          Set the two  delimiter  characters  that  indicate  the
          beginnings  of  logical  page  sections; if only one is
          given, the second remains ':'.  To enter '\', use '\\'.

     --help
          Print a usage message and exit with a non-zero status.

     --version
          Print version information on standard error then exit.













































FSF              Last change: GNU Text Utilities                3



