


RCSDIFF(1)               USER COMMANDS                 RCSDIFF(1)



NAME
     rcsdiff - compare RCS revisions

SYNOPSIS
     rcsdiff [ -ksubst ] [ -q ] [ -rrev1 [ -rrev2 ] ] [ -Vn  ]  [
     diff options ] file ...

DESCRIPTION
     rcsdiff runs diff(1) to compare two revisions  of  each  RCS
     file  given.   A file name ending in ,v is an RCS file name,
     otherwise a working file name.  rcsdiff derives the  working
     file  name  from  the  RCS  file  name  and  vice  versa, as
     explained in co(1).  Pairs consisting of both an RCS  and  a
     working file name may also be specified.

     The option -q suppresses diagnostic output.  Zero,  one,  or
     two  revisions may be specified with -r.  The option -ksubst
     affects keyword substitution when extracting  revisions,  as
     described  in  co(1);  for  example, -kk -r1.1 -r1.2 ignores
     differences in keyword values when comparing  revisions  1.1
     and  1.2.  To avoid excess output from locker name substitu-
     tion, -kkvl is assumed if (1) at most one revision option is
     given,  (2)  no  -k option is given, (3) -kkv is the default
     keyword substitution, and (4) the working file's mode  would
     be produced by co -l.  See co(1) for details about -V.  Oth-
     erwise, all options of diff(1) that apply to  regular  files
     are accepted, with the same meaning as for diff.

     If both rev1 and rev2  are  omitted,  rcsdiff  compares  the
     latest revision on the default branch (by default the trunk)
     with the contents of the corresponding working  file.   This
     is  useful  for  determining what you changed since the last
     checkin.

     If rev1 is given, but  rev2  is  omitted,  rcsdiff  compares
     revision  rev1  of  the  RCS  file  with the contents of the
     corresponding working file.

     If both rev1 and rev2 are given, rcsdiff compares  revisions
     rev1 and rev2 of the RCS file.

     Both rev1 and rev2 may be given numerically or symbolically.

EXAMPLE
     The command

             rcsdiff  f.c

     compares the latest revision on the default  branch  of  the
     RCS file RCS/f.c,v to the contents of the working file f.c.





GNU                  Last change: 1990/09/26                    1






RCSDIFF(1)               USER COMMANDS                 RCSDIFF(1)



DIAGNOSTICS
     Exit status is 0 for no differences during any comparison, 1
     for some differences, 2 for trouble.

IDENTIFICATION
     Author: Walter F. Tichy.
     Revision Number: 5.2; Release Date: 1990/09/26.
     Copyright (c) 1982, 1988, 1989 by Walter F. Tichy.
     Copyright (c) 1990 by Paul Eggert.

SEE ALSO
     ci(1),  co(1),  diff(1),  ident(1),   rcs(1),   rcsintro(1),
     rcsmerge(1), rlog(1)
     Walter  F.  Tichy,  RCS--A  System  for   Version   Control,
     Software--Practice & Experience 15, 7 (July 1985), 637-654.








































GNU                  Last change: 1990/09/26                    2



