/* tailor.h -- target dependent definitions
 * Copyright (C) 1992-1993 Jean-loup Gailly.
 * This is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License, see the file COPYING.
 */

/* simplified for ispell program
 * P.V. Ganelin
 */


/* The target dependent definitions should be defined here only.
 * The target dependent functions should be defined in tailor.c.
 */


#if defined(__MSDOS__) && !defined(MSDOS)
#  define MSDOS
#endif


#ifdef MSDOS
#  ifdef __GNUC__
     /* DJGPP version 1.09+ on MS-DOS.
      * The DJGPP 1.09 stat() function must be upgraded before gzip will
      * fully work.
      * No need for DIRENT, since <unistd.h> defines POSIX_SOURCE which
      * implies DIRENT.
      */
#  else
#     define PATH_SEP  '\\'
#     define PATH_SEPS "\\"
#     ifdef __TURBOC__
#        define RETSIGTYPE void
#     endif
#  endif
#  define NO_PIPE
#  define MAX_PATH_LEN  128
#  define NO_MULTIPLE_DOTS
#  define DEFAULT_EXEDIR
#  define unlink remove
#  define link   rename
#endif


#ifndef PATH_SEP
#  define PATH_SEP '/'
#endif

#ifndef PATH_SEPS
#  define PATH_SEPS "/"
#endif
